import java.io. *;
import java.math.BigDecimal;

/* 親クラス */

public class Datasc {
    public static void main(String[] args) {

	System.out.println("WAV/AIFFファイル データサイズ計算プログラム");

        Datasc01 k01 = new Datasc01();
	k01.main01();

    }
}


/* サンプリングレート入力 */

class Datasc01 {
  void main01(){

	InputStreamReader iar = new InputStreamReader(System.in);
	BufferedReader br = new BufferedReader(iar);

	System.out.println("");
	System.out.print("サンプリングレート(Hz)を入力してください(11025～384000まで):");

	try {

		String kb1 = br.readLine();

		long val1 = 0;  /* 入力サンプリングレート値　初期化 */

		val1 = Integer.parseInt(kb1);

		if ( val1 > 384000 ){
			System.out.println("入力可能なサンプリングレートは384000Hz未満です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val1 < 11025 ){
			System.out.println("入力可能なBPM値は11025Hz以上です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("入力されたサンプリングレートは " + val1 + " Hzです");

/* ビットレート表示 */

	System.out.print("ビットレート(bit)を入力してください(4～128まで):");

	try {

		String kb2 = br.readLine();

		long val2 = 0;  /* 入力ビットレート値　初期化 */

		val2 = Integer.parseInt(kb2);

		if ( val2 > 128 ){
			System.out.println("入力可能なビットレートは128bit未満です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val2 < 4 ){
			System.out.println("入力可能なビットレートは4bit以上です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("入力されたビットレートは " + val2 + " bitです");

/* チャンネル数表示 */

	System.out.print("レコーディングチャンネル数を入力してください(1～10まで):");

	try {

		String kb3 = br.readLine();

		long val3 = 0;  /* 入力チャンネル数値　初期化 */

		val3 = Integer.parseInt(kb3);

		if ( val3 > 10 ){
			System.out.println("入力可能なチャンネル数は10ch未満です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( val3 < 1 ){
			System.out.println("入力可能なチャンネル数は1ch以上です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("入力されたチャンネル数は " + val3 + " chです。");

/* 秒数入力 */

	System.out.print("レコーディングした秒数を入力してください(1～36000まで):");

	try {

		String kb4 = br.readLine();

		long t1 = 0;  /* 入力秒数値　初期化 */

		t1 = Integer.parseInt(kb4);

		if ( t1 > 36000 ){
			System.out.println("入力可能な秒数は36000秒(10時間)未満です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		if ( t1 < 1 ){
			System.out.println("入力可能な秒数は1秒以上です。");
    			Datasc01 k01 = new Datasc01();
			k01.main01();
		}

		System.out.println("入力された秒数は " + t1 + " 秒です。");
		System.out.println("");


		/* 結果表示 一秒あたりのサイズ */

		System.out.println("");
		System.out.println("");
		System.out.println("「" + val1 + "Hz 」 「" + val2 + "bit 」 「" + val3 + "チャンネル 」 の設定において");
		System.out.println("「" + t1 + "秒 」 レコーディングされているWAV/AIFFファイルについて計算します。");
		System.out.println("");

		long val4 = (val1 * val2 * val3);
		System.out.println("一秒あたりのオーディオデータサイズは " + val4 + " bpsです。");

		BigDecimal bdv01 = new BigDecimal(val4).divide(new BigDecimal("8.0"));
		BigDecimal bdv02 = bdv01.setScale(3, BigDecimal.ROUND_HALF_UP);
		System.out.println("単位変換すると、バイトでは " + bdv02 + " Byte/秒です。");


		BigDecimal bdv03 = bdv02.divide(new BigDecimal("1024.0"));
		BigDecimal bdv04 = bdv03.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdv03.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("キビバイト値は1KiB/秒未満です。");
		} else {
			System.out.println("キビバイト値は " + bdv04 + " KiB/秒です。");
		}

		BigDecimal bdv05 = bdv04.divide(new BigDecimal("1024.0"));
		BigDecimal bdv06 = bdv05.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdv06.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("メビバイト値は1MiB/秒未満です。");
		} else {
			System.out.println("メビバイト値は " + bdv06 + " MiB/秒です。");
		}

		System.out.println("");


		/* 結果表示 ファイルサイズ */

		long t2 = ( t1 * val4 );
		System.out.println("WAV/AIFFのファイルサイズは " + t2 + " bitです。");

		BigDecimal bdt01 = new BigDecimal(t2).divide(new BigDecimal("8.0"));
		BigDecimal bdt02 = bdt01.setScale(3, BigDecimal.ROUND_HALF_UP);
		System.out.println("単位変換すると、バイトでは " + bdt02 + " Byteです。");

		BigDecimal bdt03 = bdt02.divide(new BigDecimal("1024.0"));
		BigDecimal bdt04 = bdt03.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt03.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("キビバイト値は1KiB未満です。");
		} else {
			System.out.println("キビバイト値は " + bdt04 + " KiBです。");
		}

		BigDecimal bdt05 = bdt04.divide(new BigDecimal("1024.0"));
		BigDecimal bdt06 = bdt05.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt06.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("メビバイト値は1MiB未満です。");
		} else {
			System.out.println("メビバイト値は " + bdt06 + " MiBです。");
		}

		BigDecimal bdt07 = bdt06.divide(new BigDecimal("1024.0"));
		BigDecimal bdt08 = bdt07.setScale(3, BigDecimal.ROUND_HALF_UP);
		if ( bdt08.compareTo(BigDecimal.ONE) < 1 ){
			System.out.println("ギビバイト値は1GiB未満です。");
		} else {
			System.out.println("ギビバイト値は " + bdt08 + " GiBです。");
		}


		System.out.println("");
		System.exit(0); 


	} catch (IOException e) {
		System.out.println("数値を入力してください。");
	} catch (NumberFormatException e) {
		System.out.println("数値を入力してください。");
	}

	} catch (IOException e) {
		System.out.println("数値を入力してください。");
	} catch (NumberFormatException e) {
		System.out.println("数値を入力してください。");
	}


	} catch (IOException e) {
		System.out.println("数値を入力してください。");
	} catch (NumberFormatException e) {
		System.out.println("数値を入力してください。");
	}


	} catch (IOException e) {
		System.out.println("数値を入力してください。");
	} catch (NumberFormatException e) {
		System.out.println("数値を入力してください。");
	}

  }
}




